/* Agent Tcl
   Bob Gray
   18 April 1996

   genDefaults.h

   This file defines default directories and the like.
*/

#ifndef _GEN_DEFAULTS_H
#define _GEN_DEFAULTS_H

#ifndef NO_PRAGMAS
#pragma interface
#endif

    /* default agent directory and the name of the environment variable */
    /* that can be used to override the default agent directory         */

const char *const DEFAULT_AGENT_DIRECTORY	= "~/.agenttcl";
const char *const AGENT_DIRECTORY_ENV 	 	= "AGENTPATH";

    /* default directory in which to create agent temporary files and   */
    /* the name of the environment variable that can be used to         */
    /* override this directory						*/

const char *const DEFAULT_AGENT_TEMP		= "/tmp";
const char *const AGENT_TEMP_ENV		= "AGENTTEMP";

    /* name of the environment variable that might contain the keyname */

const char *const AGENT_KEY_ENV			= "AGENTKEY";

    /* name of the environment variable that might contain the pass phrase */

const char *const AGENT_PASS_ENV		= "AGENTPASS";

    /* name of the environment variable the might contain the TCP/IP port */

const char *const AGENT_TCPIP_ENV		= "AGENT_TCPIP_SOCKET";

    /* name of the environment variable the might contain the Unix socket name */

const char *const AGENT_UNIX_ENV		= "AGENT_UNIX_SOCKET";

#endif    /* _GEN_DEFAULTS_H */
